/*
 * Copyright (C) 2006, 2007 Apple Inc. All rights reserved.
 * Copyright (C) 2006 Michael Emmel mike.emmel@gmail.com
 * Copyright (C) 2007 Alp Toker <alp.toker@collabora.co.uk>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  Neither the name of Apple Computer, Inc. ("Apple") nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "GlyphPage.h"

#include "CairoUtilities.h"
#include "CharacterProperties.h"
#include "Font.h"
#include "FontCascade.h"
#include "UTF16UChar32Iterator.h"
#include <cairo-ft.h>
#include <cairo.h>
#include <fontconfig/fcfreetype.h>
#include <wtf/Optional.h>

namespace WebCore {

static const FT_Encoding fcFontEncodings[] = {
    FT_ENCODING_UNICODE,
    FT_ENCODING_MS_SYMBOL
};

#define NUM_DECODE  (int) (sizeof (fcFontEncodings) / sizeof (fcFontEncodings[0]))

DLL_PUBLIC Glyph FontPlatformData::getGlyphIndex(FT_Face face, cairo_scaled_font_t *scaled_font, cairo_user_scaled_font_unicode_to_glyph_func_t unicode_to_glyph_func, FcChar32 ucs4)
{
	if (face) {
		for(int i = 0; i < NUM_DECODE; ++i) {
			if(!face->charmap || face->charmap->encoding != fcFontEncodings[i])
				if (!FT_Select_Charmap(face, fcFontEncodings[i]))
					continue;

			FT_UInt glyphindex = FT_Get_Char_Index (face, (FT_ULong) ucs4);
			if (glyphindex)
				return glyphindex;
		}

		return FcFreeTypeCharIndex(face, ucs4);
	}

	if (unicode_to_glyph_func) {
		unsigned long glyph_index;
		if (unicode_to_glyph_func(scaled_font, ucs4, &glyph_index) == CAIRO_STATUS_SUCCESS)
			return glyph_index;
	}

	return 0;
}

bool GlyphPage::fill(UChar* buffer, unsigned bufferLength, const Font* font)
{
    cairo_scaled_font_t* scaledFont = font->platformData().scaledFont();
    if(!scaledFont)
    	return false;

    cairo_user_scaled_font_unicode_to_glyph_func_t unicode_to_glyph_func = nullptr;

    CairoFtFaceLocker cairoFtFaceLocker(scaledFont);
    FT_Face face = cairoFtFaceLocker.ftFace();

    if (!face) {
    	cairo_font_face_t* fontFace = cairo_scaled_font_get_font_face(scaledFont);
    	if (cairo_font_face_get_type(fontFace) == CAIRO_FONT_TYPE_USER)
    		unicode_to_glyph_func = cairo_user_font_face_get_unicode_to_glyph_func(fontFace);
    }

    WTF::Optional<Glyph> zeroWidthSpaceGlyphValue;
    auto zeroWidthSpaceGlyph =
        [&] {
            if (!zeroWidthSpaceGlyphValue)
                zeroWidthSpaceGlyphValue = FontPlatformData::getGlyphIndex(face, scaledFont, unicode_to_glyph_func, zeroWidthSpace);
            return *zeroWidthSpaceGlyphValue;
        };

    const FontCharReplaceMap& charReplaceMap = font->platformData().charReplaceMap();

    bool haveGlyphs = false;
    UTF16UChar32Iterator iterator(buffer, bufferLength);
    for (unsigned i = 0; i < GlyphPage::size; i++) {
        UChar32 character = iterator.next();
        if (character == iterator.end())
            break;

    	// look for per-font replacement character
    	FontCharReplaceMap::const_iterator it = charReplaceMap.find(character);
    	if(it != charReplaceMap.end())
    		character = it->second;

        Glyph glyph = FontPlatformData::getGlyphIndex(face, scaledFont, unicode_to_glyph_func, FontCascade::treatAsSpace(character) ? space : character);
        // If the font doesn't support a Default_Ignorable character, replace it with zero with space.
        if (!glyph && (isDefaultIgnorableCodePoint(character) || isControlCharacter(character)))
			glyph = zeroWidthSpaceGlyph();

        if (glyph){
        	setGlyphForIndex(i, glyph);
            haveGlyphs = true;
        }
        else
        	setGlyphForIndex(i, 0);
    }

    return haveGlyphs;
}

}
